Hot News:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  Lisp
  MV-Block geänderte Werte zurückschreiben

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
  
Gut zu wissen: Hilfreiche Tipps und Tricks aus der Praxis prägnant, und auf den Punkt gebracht für Autodesk Produkte
Autor Thema:  MV-Block geänderte Werte zurückschreiben (164 mal gelesen)
cadking
Mitglied
CAD-Zeichendiensleistung


Sehen Sie sich das Profil von cadking an!   Senden Sie eine Private Message an cadking  Schreiben Sie einen Gästebucheintrag für cadking

Beiträge: 237
Registriert: 26.10.2004

Intel Quadcore i7,W7-64bit, Quadro FX 3800
MEP/ACA2018; MEP/ACA2018; MEP/ACA2021; MEP/ACA2021

erstellt am: 08. Okt. 2021 08:03    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Lisp-Experten,
ich habe mir aus MV-Blöcken in einer Zeichnung folgende Werte ermittelt:
(setq ObjnameMVB (ssname get_MV-BLOCK lauf));holt Entityname von MV-Block
(setq ObjnameMVBVLA (vlax-ename->vla-object ObjnameMVB));holt VLA-Objektname von MV-Block

(setq MVBlockDefName (vlax-get-property ObjnameMVBVLA "StyleName"))

(setq scalex (vlax-get-property ObjnameMVBVLA "ScaleX"))
(setq scalez (vlax-get-property ObjnameMVBVLA "ScaleZ"))
(setq scaley (vlax-get-property ObjnameMVBVLA "ScaleY"))

(setq einfp (vlax-get ObjnameMVBVLA "Location"))
(setq einfpx (car einfp))
(setq einfpy (car (cdr einfp)))
(setq einfpz (car (cddr einfp)))

bis hier hat alles prima funktioniert
nun möchte ich die folgenden Werte an die MV-Blöcke zurück schreiben:

(setq scalexnew (* scalex 1000))
(setq scaleznew (* scalez 1000))
(setq scaleynew (* scaley 1000))
und der "StyleName" soll geändert werden.

(entget ObjnameMVB) liefert nur:
((-1 . <Objektname: 187f25ba320> ) (0 . "AEC_MVBLOCK_REF") (330 . <Objektname: 187b09fd020> ) (5 . "5AA") (100 . "AcDbEntity") (67 . 0) (410 . "Model") (8 . "A-ASPR-NEU"))
Ich finde keine passenden Gruppencodes die ich mit (entmod ..) austauschen kann.
Wie kann ich die geänderten Werte an den MV-Block zurückschreiben?

Danke für Eure Hilfe.

------------------
Danke Stefan

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadking
Mitglied
CAD-Zeichendiensleistung


Sehen Sie sich das Profil von cadking an!   Senden Sie eine Private Message an cadking  Schreiben Sie einen Gästebucheintrag für cadking

Beiträge: 237
Registriert: 26.10.2004

Intel Quadcore i7,W7-64bit, Quadro FX 3800
MEP/ACA2018; MEP/ACA2018; MEP/ACA2021; MEP/ACA2021

erstellt am: 08. Okt. 2021 08:36    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Noch eine weiter Frage:
(setq einfp (vlax-get ObjnameMVBVLA "Location"))
liefert nur gerundete Werte (6975.0 51957.8 0.0)
der exakte Wert wäre (6975.00000000  51957.81262714 0.00000000)

Kann (vlax-get ObjnameMVBVLA "Location") auch die exakten Werte zurückgeben?

------------------
Danke Stefan

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Andreas Kraus
Mitglied
Elektrotechniker


Sehen Sie sich das Profil von Andreas Kraus an!   Senden Sie eine Private Message an Andreas Kraus  Schreiben Sie einen Gästebucheintrag für Andreas Kraus

Beiträge: 1267
Registriert: 11.01.2006

WIN 10
ACAD 2017

erstellt am: 08. Okt. 2021 09:45    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für cadking 10 Unities + Antwort hilfreich

Hallo cadking,
du holst dir mit vlax-get-property die Skalierungen.
Was spricht dagegen mit vlax-put-property diese zurückzuschreiben ?

Ich hab hier keine MVBlöcke und kann das nicht ausprobieren, sollte doch aber gehen.

------------------
Geht nicht, gibts nicht

Gruß
Andreas

http://kraus-cad.de

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadking
Mitglied
CAD-Zeichendiensleistung


Sehen Sie sich das Profil von cadking an!   Senden Sie eine Private Message an cadking  Schreiben Sie einen Gästebucheintrag für cadking

Beiträge: 237
Registriert: 26.10.2004

Intel Quadcore i7,W7-64bit, Quadro FX 3800
MEP/ACA2018; MEP/ACA2018; MEP/ACA2021; MEP/ACA2021

erstellt am: 08. Okt. 2021 11:56    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Andreas,
du hast natürlich recht. Es spricht nichts dagegen und funktioniert auch soweit, nur:
ich ermittel den Einfügepunkt:
(setq einfp (vlax-get ObjnameMVBVLA "Location"))

berechne den neuen Einfügepunkt:
(setq einfpxnew (+ einfpx (*(/ scalex 2) 1000)))
(setq einfpznew (+ einfpz (*(/ scalex 2) 1000)))
(setq einfpnew (list einfpxnew einfpy einfpznew))

aber (vlax-put ObjnameMVBVLA "Location" einfpnew) hat keine Auswirkung auf die Position des MV-Blocks.

------------------
Danke Stefan

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadking
Mitglied
CAD-Zeichendiensleistung


Sehen Sie sich das Profil von cadking an!   Senden Sie eine Private Message an cadking  Schreiben Sie einen Gästebucheintrag für cadking

Beiträge: 237
Registriert: 26.10.2004

Intel Quadcore i7,W7-64bit, Quadro FX 3800
MEP/ACA2018; MEP/ACA2018; MEP/ACA2021; MEP/ACA2021

erstellt am: 08. Okt. 2021 12:11    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Sorry,
man darf die Codezeilen natürlich nicht in einen "ausgeREMten Bereich setzen, dann funktioniert
(vlax-put ObjnameMVBVLA "Location" einfpnew)
auch.


------------------
Danke Stefan

[Diese Nachricht wurde von cadking am 08. Okt. 2021 editiert.]

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADmium
Moderator
Maschinenbaukonstrukteur




Sehen Sie sich das Profil von CADmium an!   Senden Sie eine Private Message an CADmium  Schreiben Sie einen Gästebucheintrag für CADmium

Beiträge: 13497
Registriert: 30.11.2003

.

erstellt am: 11. Okt. 2021 20:42    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für cadking 10 Unities + Antwort hilfreich

zu
(setq einfpxnew (+ einfpx (*(/ scalex 2) 1000)))
besser
(setq einfpxnew (+ einfpx (*(/ scalex 2.0) 1000)))

Teste mal dazu (/ 8 3)  und (/ 8 3.0)

------------------
Also ich finde Unities gut ... und andere sicher auch
---------------------------------------
  - Thomas -          
"Bei 99% aller Probleme ist die umfassende Beschreibung des Problems bereits mehr als die Hälfte der Lösung desselben."

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadking
Mitglied
CAD-Zeichendiensleistung


Sehen Sie sich das Profil von cadking an!   Senden Sie eine Private Message an cadking  Schreiben Sie einen Gästebucheintrag für cadking

Beiträge: 237
Registriert: 26.10.2004

Intel Quadcore i7,W7-64bit, Quadro FX 3800
MEP/ACA2018; MEP/ACA2018; MEP/ACA2021; MEP/ACA2021

erstellt am: 12. Okt. 2021 13:56    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

hallo CADmium,
berechtigter Hinweis, vielen Dank.
gas hätte auch schief gehen können, es handelt sich nämlich um konvertierte Aussparungen. Wenn die falsch gebohrt worden wären, puhh.

------------------
Danke Stefan

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2021 CAD.de | Impressum | Datenschutz